--- channel.c   2005-12-02 00:34:58.000000000 +0100
+++ ../../channel.c-new 2005-12-30 12:48:31.998486520 +0100
@@ -96,6 +96,11 @@

 static int uniqueint = 0;

+/*
+ * Mutex required for uniqueint synchronization
+ */
+AST_MUTEX_DEFINE_STATIC(ast_unique_increase_lock);
+
 unsigned long global_fin = 0, global_fout = 0;

 /* XXX Lock appropriately in more functions XXX */
@@ -583,7 +588,13 @@
        tmp->data = NULL;
        tmp->fin = global_fin;
        tmp->fout = global_fout;
-       snprintf(tmp->uniqueid, sizeof(tmp->uniqueid), "%li.%d", (long) time(NULL), uniqueint++);
+
+       /* Lock the uniqueint mutex before incrementing */
+       ast_mutex_lock(&ast_unique_increase_lock);
+       uniqueint++;
+       snprintf(tmp->uniqueid, sizeof(tmp->uniqueid), "%li.%d", (long) time(NULL),uniqueint);
+       ast_mutex_unlock(&ast_unique_increase_lock);
+
        headp = &tmp->varshead;
        ast_mutex_init(&tmp->lock);
        AST_LIST_HEAD_INIT_NOLOCK(headp);
